/*
 * af.h
 * Copyright (C) 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_af_H__
#define __LIBx1f4_af_H__

#include <nl.h>
#include <nt.h>

#define _x1f4_lead_effect		x1f4_lead_effect
#define _x1f4_slip_effect		x1f4_slip_effect
#define _x1f4_type_effect		x1f4_type_effect

extern int _x1f4_free_effect
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _x1f4_lead_effect(void *, void **);
extern int _x1f4_node_effect
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _x1f4_slip_effect(void *, void **);
extern int _x1f4_type_effect(struct x1f4_nodetype_type *, int);

#endif				/* __LIBx1f4_af_H__ */
