/*
 * dlxy.6.c
 * Copyright (C) 2008-2010, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <dlxx-defs.h>
#include <dlxx-inter.h>
#include <dlxx-names.h>

#define dllist(dllist)			((struct dllist_type *) (dllist))

int
x1f4_flat_dllist(void *dllist)
{
    int status;

    status = _libx1f4l2_ceil_dllist(dllist);
    if (status) {
    } else {
	struct fpnode_type *fpnode_data;

	fpnode_data = dllist(dllist)->link_a.fplist.link_x.fpnode_data;
	if (fpnode_data) {
	    status = dllist(dllist)->link_m.free
		(dllist(dllist)->link_m.data, fpnode_data);
	    if (status) {
		status = FREE_ERROR;
	    }
	}
    }

    return status;
}
