/*
 * e4ll.7.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4ll-types.h>
#include <frame.h>

int
x1f4_heed_e4ll(void *e4less, void *scope)
{
    struct e4less_type *e4less_data;
    struct scope_type *scope_data;

    e4less_data = e4less;

    scope_data = scope;

    scope_data->data = e4less_data->link_a.data;

    scope_data->deck = e4less_data->link_a.deck;
    scope_data->fini = e4less_data->link_a.fini;
    scope_data->init = e4less_data->link_a.init;
    scope_data->swap = e4less_data->link_a.swap;

    return 0;
}
