/*
 * file.i.2.c
 * Copyright (C) 2008, 2009, 2013, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <file-defs.h>
#include <file-inter.h>
#include <file-types.h>

#define file(file) \
    ((struct eifile_type *) (file))

int
_libx1f4i0_over_ifile(void *file)
{
    int (*over)(void *), status;

    over = file(file)->sf->over;
    if (over) {
	status = over(&file(file)->sd);
	if (status) {
	    status = FREE_CLASS;
	}
    } else {
	status = 0;
    }

    return status;
}
