/*
 * lxfile-e.r.c
 * Copyright (C) 2010, 2011, 2013-2017, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxfile-inter.h>
#include <lxnote.h>

static const struct x1f4_lxnote_type fail_note = {
/* *INDENT-OFF* */
    _libx1f4i0_lxlong_bset_long,
    NULL,
    _libx1f4i0_lxfile_clip_file,
    _libx1f4i0_lxfile_dset_file,
    _libx1f4i0_lxfile_fini_file,
    NULL,
    _libx1f4i0_lxfile_fset_file,
    NULL,
    NULL,
    _libx1f4i0_lxlong_near_long,
    NULL,
    NULL,
    _libx1f4i0_lxfile_seek_file,
    _libx1f4i0_lxfile_suit_file,
    _libx1f4i0_lxfile_tile_file,
    NULL,
    NULL,
    _libx1f4i0_lxfile_vset_file,
    _libx1f4i0_lxfile_wrap_file,
    X1f4_LXNOTE_OFFSUITE
/* *INDENT-ON* */
};

int
x1f4_note_lxfile(const struct x1f4_lxnote_type **lxnote)
{
    *lxnote = &fail_note;

    return 0;
}
