/*
 * lxlead-e.q.c
 * Copyright (C) 2011-2012, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <cl.h>
#include <lxcall.h>
#include <trans.h>

int
x1f4_lose_lxlead(struct x1f4_caselink_type *caselink_data,
		 struct trans_type *trans_data)
{
    int status = 0;

    while (caselink_data) {
	int excess;
	struct x1f4_caselink_type *caselink_text;

	caselink_text = caselink_data->caselink_data;

	excess = trans_data->free(trans_data->data, caselink_data);
	if (excess) {
	    status = _libx1f4i0_lxcall_land_slip(excess, status);
	}

	caselink_data = caselink_text;
    }

    return status;
}
