/*
 * lxmile-e.n.c
 * Copyright (C) 2008-2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxcall.h>
#include <lxmile-inter.h>
#include <lxmile-types.h>
#include <tcvset.h>

int
_libx1f4i0_lxmile_fine_mile(void *subtext, void *dxpart)
{
    int status;
    struct dxmile_type *dxpart_data;
    struct lxmile_type *lxmile_data;

    lxmile_data = ((struct lxtext_type *) subtext)->part;

    dxpart_data = dxpart;
    if (0) {
    } else {
	if (0) {
	} else {
	    int (*call)(void *, struct x1f4_nodelink_type *), excess,
		(*flat)(void *, void *);

	    status = _libx1f4i0_fini_tcvset
		(&lock_expart(dxpart_data)->pset,
		 &lock_expart(dxpart_data)->text,
		 (void *) &lxmile_data->link_m);
	    if (status) {
		status = _libx1f4i0_lxmile_stat_free(lxmile_data, 0);
	    }

	    call = lxmile_data->link_r.call;
	    if (call) {
		call(lxmile_data->link_r.text, lock_excase(dxpart));
	    }

	    flat = ((struct lxtext_type *) subtext)->flat;
	    if (flat) {
		excess = flat(((struct lxtext_type *) subtext)->text, dxpart);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }

	    excess = lxmile_data->link_m.free
		(lxmile_data->link_m.data, lock_cxpart(dxpart_data));
	    if (excess) {
		status = _libx1f4i0_lxmile_stat_free(lxmile_data, status);
	    }
	}
    }

    return status;
}
