/*
 * lxnext.h
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxnext_H__
#define __LIBx1f4_lxnext_H__

#include <nl.h>

extern int _libx1f4i0_lxnext_free_text
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxnext_copy_text
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxnext_lead_text(void *, void **);
extern int _libx1f4i0_lxnext_push_text
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxnext_slip_text(void *, void **);

#endif				/* __LIBx1f4_lxnext_H__ */
