/*
 * lxtrap-i.c.c
 * Copyright (C) 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <af.h>
#include <e4.h>
#include <lxtrap-inter.h>

int
_libx1f4i0_lxtrap_high_news(void *text, void *data,
			    struct x1f4_nodelink_type **nodelink)
{
#if 0
    return _libx1f4i0_lxtrap_free_args
	((void *) ((struct x1f4_linetext_type *) data + 1), nodelink);
#else
    int excess, status = 0;
    struct dxnews_type *line_data;
    struct x1f4_linetext_type *linetext_data;

    line_data = (void *) ((struct x1f4_linetext_type *) data + 1);

    /*
     * test required?
     */
    if (line_data->fold) {
	excess = _libx1f4i0_lxtrap_free_args(line_data, nodelink);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    linetext_data = line_data->linetext_data;
    if (linetext_data) {
	line_data->linetext_data = NULL;

	excess = _x1f4_free_effect
	    (NULL, linetext_data, nodelink,
	     &((struct x1f4_leadnode_type *) data - 1)->link);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    linetext_data = line_data->linetext_text;
    if (linetext_data) {
	line_data->linetext_text = NULL;

	excess = _x1f4_free_effect
	    (NULL, linetext_data, nodelink,
	     &((struct x1f4_leadnode_type *) data - 1)->link);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    return status;
#endif				/* 0 */
}
