/*
 * a12nd.m.c
 * Copyright (C) 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1i.h>

int
_x1f4_a1_slip_data(void *upcast)
{
    struct x1f4_c1lead_type *upcast_data;
    void *node;

    upcast_data = upcast;

    node = upcast_data->node;

    return node ? upcast_data->slip(upcast_data->text, &node) : 0;
}
