/*
 * e4.7.6.c
 * Copyright (C) 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4-config.h>

#include <stddef.h>

#include <e4-defs.h>
#include <e4-types.h>
#include <fd.h>

static int neon_pick(x1f4_e4_LINK_ARGS_0);

/*
 * KEEP_CALL set for the "picked" function, so here is superfluous
 */
const struct e4_last_type _x1f4_e4_neon_2 = {
/* *INDENT-OFF* */
    "un",
    neon_pick,
    0,
    NULL,
    1,
    KEEP_CALL | NEON_LINE | TEXT_LINK,
    2
/* *INDENT-ON* */
};

static int
neon_pick(x1f4_e4_LINK_ARGS_1)
{
    unsigned neon;
    void **list, **used;

    neon = *(C_MODE *) context;
    used = input[-1];
    list = used[USED_LIST];
#if 0
    the other (less clean) option:
    list = input + 1;
#endif				/* 0 */

    /*
     * not a general copier, one to the e4 post_type internal stack
     */
    *(struct fxdata_type *) output = *(struct fxdata_type *) list[1 + neon];

    return 0;
}
