/*
 * lxcast.h
 * Copyright (C) 2010, 2011, 2013, 2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxcast_H__
#define __LIBx1f4_lxcast_H__

#include <dt.h>
#include <e4.h>
#include <fd.h>

/*
 * also in e4-types, as e4_case
 */
typedef struct x1f4_dxcast_type {
    int call, type;
    struct fxdata_type data;
} x1f4_dxcast_type;

extern int x1f4_lead_lxcast(void *, void **);
extern int x1f4_pset_lxcast
    (void *, const struct x1f4_datatype_type **);
extern int x1f4_slip_lxcast(void *, void **);

#endif				/* __LIBx1f4_lxcast_H__ */
