/*
 * lxdash-e.n.c
 * Copyright (C) 2008-2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <tcvset.h>

#define lxdash(line) \
    ((struct lxdash_type *) (line))

int
_libx1f4i0_lxdash_fine_line(void *subtext, void *dxdash)
{
    int status;
    struct dxdash_type *dxdash_data;

    dxdash_data = dxdash;
    if (0) {
    } else {
	if (0) {
	} else {
	    int (*call) (void *, struct x1f4_nodelink_type *), excess;

	    status = _libx1f4i0_fini_tcvset
		(&lock_exline(dxdash_data)->pset,
		 &lock_exline(dxdash_data)->text,
		 (void *) &((struct lxdash_type *) subtext)->link_m);
	    if (status) {
		status = _libx1f4i0_lxdash_stat_free(subtext, 0);
	    }

	    call = lxdash(subtext)->link_r.call;
	    if (call) {
		call(lxdash(subtext)->link_r.text, lock_excase(dxdash));
	    }

	    excess = _libx1f4i0_flat_lxfset(dxdash_data->dash);
	    if (excess) {
		status = _libx1f4i0_lxdash_stat_line(subtext, status, excess);
	    }

	    excess = ((struct lxdash_type *) subtext)->link_m.free
		(((struct lxdash_type *) subtext)->link_m.data,
		 lock_cxline(dxdash_data));
	    if (excess) {
		status = _libx1f4i0_lxdash_stat_free(subtext, status);
	    }
	}
    }

    return status;
}
