/*
 * lxline-e.x.c
 * Copyright (C) 2010, 2011, 2013, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-inter.h>
#include <lxline-types.h>

int
x1f4_clip_lxline(unsigned bits, const void *screen,
		 struct lxtype_type **lxtype, int *line3)
{
    int cline3;
    struct lxtype_type *lxtype_data;

    lxtype_data = *lxtype;

    cline3 = *line3;

    _libx1f4i0_lxline_type_line(lxtype_data, cline3);

    cline3++;

    lxtype_data++;

    *line3 = cline3;

    *lxtype = lxtype_data;

    return 0;
}
