/*
 * lxline-f.k.c
 * Copyright (C) 2008-2013, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxdata.h>
#include <lxline-drive.h>
#include <lxline-types.h>

#define dxdata(data) \
    ((struct x1f4_dxdata_type *) (data))

#define dxline(line) \
    ((struct dxline_type *) (line))

int
_libx1f4i0_lxline_k_forward(void *context, void *output, void **input)
{
    void *data;

    l_MODE(_libx1f4i0_find_sfnote
	   (dxline(I_LINE(input[0]))->line, dxdata(I_DATA(input[1]))->string,
	    &data), output);

    return 0;
}
