/*
 * lxtime-l.c.c
 * Copyright (C) 2008, 2009, 2013, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdate-drive.h>
#include <lxdate-types.h>

#define dxtime(date) \
    ((struct dxtime_type *) (date))

int
_libx1f4i0_lxtime_c_logique(void *context, void *output, void **input)
{
    struct dxtime_type *dxtime_data;
    unsigned call;

    dxtime_data = I_TIME(input[0]);

    call = dxtime_data->call;

    *dxtime_data = *dxtime(I_TIME(input[1]));

    dxtime_data->call = call;

    l_TIME(dxtime_data, output);

    return 0;
}
